/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <paum1202@usherbrooke.ca> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return. -violette paulin 
 * ----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* get bits after n from k */
#define LAST_BITS(k,n) ((k) & ((1 << (n)) - 1))
/* get bits of k between m and n */
#define MID_BITS(k,m,n) LAST_BITS((k) >> (m), ((n) - (m)))

#define SIZE_ALPH 26
#define SIZE_MSG 32
#define SIZE_OTP 64

struct eve {
	uint32_t msg;
	uint32_t tag;
};

static inline uint32_t	mac(uint32_t, uint32_t);
static inline char	 	verif(uint32_t, uint32_t, uint32_t);
static inline uint32_t	gen();
static inline uint32_t	char_arr_to_uint32(char *);
static struct eve		eve_shenanigans(struct eve);
static char *			uint32_to_char_arr(uint32_t n);

int
main(int argc, char *argv[])
{
	srand(time(0)); /* init rand */

	uint32_t key = gen();
	uint32_t msg = 0;

#ifdef TEST_TECH
	char *test = "yay";
	printf("Testing char_arr_to_uint32 and uint32_to_char_arr: \n");
	char *res = uint32_to_char_arr(char_arr_to_uint32(test));
	printf("%s\n", );
	free(res);
#endif

	printf("\n--- MSG ---\n");

#ifdef TEST_ZERO
	msg = 0x00000000;
#endif

#ifdef TEST_MID
	/* is UINT16_MAX, but keeping this way for corrector convenience */
	msg = 0x0000ffff;
#endif

#ifdef TEST_MAX
	msg = 0xffffffff;
#endif

#ifdef TEST_NAME
	msg = *(uint32_t *)"bob";
#endif

	printf("as 0x: %x\n", msg);

	char *msg_char = uint32_to_char_arr(msg);
	printf("as char *: %s\nas uint32: %u\n",
			msg_char, msg);

	free(msg_char);

	uint32_t tag = mac(msg, key);
	printf("--- TAG ---\n%d \n", tag);

	printf("--- VERIF ---\n%d\n", 
			verif(key, msg, tag));


	printf("\n--- ALICE ---\n");
	printf("sends msg: %u\nsends tag: %u\n", msg, tag);
	printf("knows key: %u\n", key);


	printf("\n--- EVE ---\n");
	printf("recieves msg: %u\nrecieves tag: %u\n", msg, tag);
	struct eve tmp = { msg, tag };
	tmp = eve_shenanigans(tmp);
	msg = tmp.msg, tag = tmp.tag;
	printf("sends msg: %u\nsends tag: %u\n", msg, tag);


	printf("\n--- BOB ---\n");
	printf("recieves msg: %u\nrecieves tag: %u\n", msg, tag);
	printf("knows key: %u\n", key);

	char res = verif(msg, tag, key);
	printf("verifies: %s\n", res ? "TRUE" : "FALSE");

	if (res) {
		msg_char = uint32_to_char_arr(msg);
		printf("msg as char *: %s\n", msg_char);
		free(msg_char);
	}

	return 0;
}

static inline uint32_t
gen()
{
	/* rand is between 0 and UINT32_MAX - 1 / 2 (because sign) */
	return rand() + rand() + (rand() % 1);
}

static struct eve
eve_shenanigans(struct eve str)
{
#ifdef EVE_ZERO
	uint32_t old_msg = str.msg;
	str.msg = 0x00000000;
	str.tag = str.tag ^ old_msg ^ str.msg;
#endif

#ifdef EVE_MID
	uint32_t old_msg = str.msg;
	str.msg = 0x0000ffff;
	str.tag = str.tag ^ old_msg ^ str.msg;
#endif

#ifdef EVE_MAX
	uint32_t old_msg = str.msg;
	str.msg = 0xffffffff;
	str.tag = str.tag ^ old_msg ^ str.msg;
#endif

#ifdef EVE_NAME
	uint32_t old_msg = str.msg;
	str.msg = *(uint32_t *)"eve";
	str.tag = str.tag ^ old_msg ^ str.msg;
#endif

	return str;
}

static inline char
verif(uint32_t key, uint32_t msg, uint32_t tag)
{
	return (key ^ msg) == tag;
}

static inline uint32_t
mac(uint32_t key, uint32_t msg)
{
	return msg ^ key;
}

static inline uint32_t
char_arr_to_uint32(char *arr)
{
	return *(uint32_t *)arr;
}

static char *
uint32_to_char_arr(uint32_t n)
{
	char *res = calloc(5, 1);
	res[0] = MID_BITS(n, 0, 8);
	res[1] = MID_BITS(n, 8, 16);
	res[2] = MID_BITS(n, 16, 24);
	res[3] = MID_BITS(n, 24, 32);
	/* care for terminating nullbyte ! */
	res[4] = '\0';

	return res;
}
